package com.steerinfo.baseinfo.meterbaseverificationcode.controller;

import com.steerinfo.baseinfo.meterbaseverificationcode.mapper.MeterBaseVerificationCodeMapper;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbaseverificationcode.model.MeterBaseVerificationCode;
import com.steerinfo.baseinfo.meterbaseverificationcode.service.IMeterBaseVerificationCodeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.*;
import java.math.BigDecimal;

/**
 * MeterBaseVerificationCode RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-09 03:32
 * 类描述
 * 修订历史：
 * 日期：2022-03-09
 * 作者：generator
 * 参考：
 * 描述：MeterBaseVerificationCode RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseverificationcodes")
@Api(value = "/${api.version}/meterbaseverificationcodes", tags = "验证码信息 - MeterBaseVerificationCodeController")
public class MeterBaseVerificationCodeController extends BaseRESTfulController {

    @Autowired
    IMeterBaseVerificationCodeService meterBaseVerificationCodeService;

    @Autowired
    MeterBaseVerificationCodeMapper meterBaseVerificationCodeMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseverificationcode:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseVerificationCode> list = meterBaseVerificationCodeService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseverificationcode:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseVerificationCode> list = meterBaseVerificationCodeService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseVerificationCode对象创建")
    @ApiImplicitParam(name = "meterBaseVerificationCode", value = "详细实体meterBaseVerificationCode", required = true, dataType = "MeterBaseVerificationCode")
    //@RequiresPermissions("meterbaseverificationcode:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody HashMap parma){
        //发送验证码


        MeterBaseVerificationCode model = new MeterBaseVerificationCode();
        String no = meterBaseVerificationCodeMapper.GetNewID();
        model.setVerificationCodeNo(new SimpleDateFormat("yyyyMMdd").format(new Date()) + no);
        model.setCreateTime(new Date());
        model.setPhoneNumber(parma.get("phoneNumber").toString());
        model.setValidFlag("0");
        model.setVaildTime(new Date());
        model.setVerificationCode("");
        meterBaseVerificationCodeMapper.insertSelective(model);
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseverificationcode:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseVerificationCode meterBaseVerificationCode = meterBaseVerificationCodeService.getById(id);
        return success(meterBaseVerificationCode);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseVerificationCode信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseVerificationCode", value = "详细实体meterBaseVerificationCode", required = true, dataType = "MeterBaseVerificationCode")
    })
    //@RequiresPermissions("meterbaseverificationcode:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseVerificationCode model){
        model.setId(id);
        MeterBaseVerificationCode meterBaseVerificationCode = meterBaseVerificationCodeService.modify(model);
        return success(meterBaseVerificationCode);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseverificationcode:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseVerificationCodeService.delete(ids);
    	}
      return success();
    }
}
